#!/usr/bin/python3 
import select
import _thread
import socket
import sys
import Queue
import time
import schedule
import os
from threading import Thread
import RPi.GPIO as GPIO 

GPIO.setmode(GPIO.BCM)
GPIO.setup(26, GPIO.IN, pull_up_down=GPIO.PUD_UP)  

Counter = 0
Zaehler = 0
i = 0

# Create a TCP/IP socket
server = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
server.setblocking(0)

# Bind the socket to the port
server_address = ('10.0.0.41', 55041)
print (sys.stderr, 'starting up on %s port %s' % server_address)
server.bind(server_address)

# Listen for incoming connections
server.listen(5)
# Sockets from which we expect to read
inputs = [ server ]

# Sockets to which we expect to write
outputs = [ ]
# Outgoing message queues (socket:Queue)
message_queues = {}

GPIO.setmode(GPIO.BCM)
GPIO.setup(26, GPIO.IN, pull_up_down=GPIO.PUD_UP)  

Counter = 0
i = 0

def job():
    global Counter
    global Zaehler
    global Viertelstundenwert
    Viertelstundenwert = time.strftime("%d.%m.%Y %H:%M:%S")+";"+str(Counter)
    #Filename = time.strftime("%d.%m.%Y_%H:%M:%S")+".txt"
    print ('Viertelstundenwert = ', Viertelstundenwert)
    file = open ("/home/pi/Templates/ATuEM/Data/Viertelstundenwerte.txt", "a")
    file.write(Viertelstundenwert+"\r\n")
    file.close()
    Counter = 0
    Antwort = "VW" #+time.strftime('%d.%m.%Y %H:%M:%S')+"\r\n"
    Antwort = Antwort.encode('utf-8')
    s.send(Antwort)

def socke():
    while inputs:

        # Wait for at least one of the sockets to be ready for processing
        print (sys.stderr, '\nwaiting for the next event')
        readable, writable, exceptional = select.select(inputs, outputs, inputs)
        for s in readable:

            if s is server:
                # A "readable" server socket is ready to accept a connection
                connection, client_address = s.accept()
                print (sys.stderr, 'new connection from', client_address)
                connection.setblocking(0)
                inputs.append(connection)

                # Give the connection a queue for data we want to send
                message_queues[connection] = Queue.Queue()
            else:
                data = s.recv(1024)
                if data:
#                     print ("E M P F A N G E N:  ",data)
#                     empfangener_Befehl = data.decode('utf-8') # binär empfangene Daten in String umwandeln
#                     empfangener_Befehl = empfangener_Befehl.rstrip('\r\n')
#                     print("Inhalt von EMPFANGEN: ",empfangener_Befehl)
#                     if empfangener_Befehl == "41_alive":
#                         Antwort = "41_alive  "+time.strftime('%d.%m.%Y %H:%M:%S')+"\r\n"
#                         Antwort = Antwort.encode('utf-8')
#                         s.send(Antwort)    
#                     if empfangener_Befehl == "41_data":
#                         Antwort = str(Counter)+";"+time.strftime('%d.%m.%Y %H:%M:%S')+"\r\n"
#                         Antwort = Antwort.encode('utf-8')
#                         s.send(Antwort)
                    
                    print (sys.stderr, 'received "%s" from %s' % (data, s.getpeername()))
                    message_queues[s].put(data)
                    # Add output channel for response
                    if s not in outputs:
                        outputs.append(s)
                else:
                     # Interpret empty result as closed connection
                     print >>sys.stderr, 'closing', client_address, 'after reading no data'
                     # Stop listening for input on the connection
                     if s in outputs:
                         outputs.remove(s)
                     inputs.remove(s)
                     s.close()
        # Handle outputs
        
#         for s in writable:
#             try:
#                 next_msg = message_queues[s].get_nowait()
#                 print ("E M P F A N G E N:  ",next_msg)
        for s in writable:
            try:
                next_msg = message_queues[s].get_nowait()
#                 print ("E M P F A N G E N:  ",next_msg)
#                 empfangener_Befehl = next_msg.decode('utf-8') # binär empfangene Daten in String umwandeln
#                 empfangener_Befehl = empfangener_Befehl.rstrip('\r\n')
#                 print("Inhalt von EMPFANGEN: ",empfangener_Befehl)
#                 if empfangener_Befehl == "41_alive":
#                     Antwort = "41_alive  "+time.strftime('%d.%m.%Y %H:%M:%S')+"\r\n"
#                     Antwort = Antwort.encode('utf-8')
#                     s.send(Antwort)    
#                 if empfangener_Befehl == "41_data":
#                     Antwort = str(Counter)+";"+time.strftime('%d.%m.%Y %H:%M:%S')+"\r\n"
#                     Antwort = Antwort.encode('utf-8')
#                     s.send(Antwort)                    
            except Queue.Empty:
                # No messages waiting so stop checking for writability.
                print (sys.stderr, 'output queue for', s.getpeername(), 'is empty')
                outputs.remove(s)
            else:
                print (sys.stderr, 'sending "%s" to %s' % (next_msg, s.getpeername()))
                
                empfangener_Befehl = next_msg.decode('utf-8') # binär empfangene Daten in String umwandeln
                empfangener_Befehl = empfangener_Befehl.rstrip('\r\n')
                print("Inhalt von EMPFANGEN: ",empfangener_Befehl)
                if empfangener_Befehl == "41_alive":
                    print (empfangener_Befehl)
                    Antwort = "ok"+"\r\n" #+time.strftime('%d.%m.%Y %H:%M:%S')+"\r\n"
                    Antwort = Antwort.encode('utf-8')
                    s.send(Antwort)    
                if empfangener_Befehl == "41_data":
                    Antwort = str(Counter)+";"+time.strftime('%d.%m.%Y %H:%M:%S')+"\r\n"
                    Antwort = Antwort.encode('utf-8')
                    s.send(Antwort)
                
                
                
                #s.send(next_msg)
                    
        # Handle "exceptional conditions"
        for s in exceptional:
            print (sys.stderr, 'handling exceptional condition for', s.getpeername())
            # Stop listening for input on the connection
            inputs.remove(s)
            if s in outputs:
                outputs.remove(s)
            s.close()

def Impuls_zaehlen():
     GPIO.add_event_detect(26, GPIO.FALLING, callback=my_callback, bouncetime=10)
     
def my_callback(channel):  
    global Counter
    print ("falling edge detected on 26")
    Counter=Counter+1
    print ("Puls-Nr.:",Counter)
    print (time.strftime("%d.%m.%Y %H:%M:%S"))
    #file = open ("Counter_temp.txt", "w")
    #file.write(str(Counter)) 
    #file.close()

# Create two threads as follows
# try:
#    #_thread.start_new_thread( socke, 0)
#    _thread.start_new_thread(zaehlen,0)
# except:
#    print ("Error: unable to start thread")
#s = Thread(target=socke, args=(0,))

def Schleife():
   while 1:
    schedule.run_pending() 


so = Thread(target=socke,)
so.start()

Iz = Thread(target=Impuls_zaehlen,)
Iz.start()

Schl = Thread(target=Schleife,)
Schl.start()

schedule.every().hour.at(":00").do(job)
schedule.every().hour.at(":15").do(job)
schedule.every().hour.at(":30").do(job)
schedule.every().hour.at(":45").do(job)

#GPIO.add_event_detect(26, GPIO.FALLING, callback=my_callback, bouncetime=10)

while 1:
    pass









